"use strict";

/**
 * @file
 * @author Andrey Galkin <andrey@futoin.org>
 *
 *
 * Copyright 2014-2017 FutoIn Project (https://futoin.org)
 * Copyright 2014-2017 Andrey Galkin <andrey@futoin.org>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var error_list = ['ConnectError', 'CommError', 'UnknownInterface', 'NotSupportedVersion', 'NotImplemented', 'Unauthorized', 'InternalError', 'InvokerError', 'InvalidRequest', 'DefenseRejected', 'PleaseReauth', 'SecurityError', 'Timeout', 'LoopBreak', 'LoopCont'];

/**
 * List of standard FutoIn Core errors. It may static get extended in runtime.
 * @var FutoInErrors
 */

var Errors = function Errors() {
  _classCallCheck(this, Errors);
};

error_list.forEach(function (v) {
  return Object.defineProperty(Errors, v, {
    enumerable: true,
    value: v
  });
});

module.exports = Errors;
//# sourceMappingURL=Errors.js.map
