'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var $as = require('../lib/main-full');
var optihelp = require('@futoin/optihelp');

var REPEAT_COUNT = 10000;
var as_i = 0;
var await_i = 0;

optihelp('Compare', { test_time: 3 }).test('AsyncSteps', function (done) {
    $as().add(function (as) {
        ++as_i;
        as.add(function (as) {
            ++as_i;
        });
    }).add(function (as) {
        return done();
    }).execute();
}).test('async-await', function (done) {
    _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        ++await_i;
                        _context2.next = 3;
                        return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                            return regeneratorRuntime.wrap(function _callee$(_context) {
                                while (1) {
                                    switch (_context.prev = _context.next) {
                                        case 0:
                                            ++await_i;

                                        case 1:
                                        case 'end':
                                            return _context.stop();
                                    }
                                }
                            }, _callee, undefined);
                        }));

                    case 3:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, undefined);
    }))().then(done);
}).test('as-repeat', function (done) {
    $as().repeat(REPEAT_COUNT, function (as, i) {
        as_i += i;
    }).add(function (as) {
        return done();
    }).execute();
}).test('await-for', function (done) {
    _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var inner, i;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        inner = function () {
                            var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(i) {
                                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                                    while (1) {
                                        switch (_context3.prev = _context3.next) {
                                            case 0:
                                                await_i += i;

                                            case 1:
                                            case 'end':
                                                return _context3.stop();
                                        }
                                    }
                                }, _callee3, undefined);
                            }));

                            return function inner(_x) {
                                return _ref4.apply(this, arguments);
                            };
                        }();

                        i = 0;

                    case 2:
                        if (!(i < REPEAT_COUNT)) {
                            _context4.next = 8;
                            break;
                        }

                        _context4.next = 5;
                        return inner(i);

                    case 5:
                        ++i;
                        _context4.next = 2;
                        break;

                    case 8:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, undefined);
    }))().then(done);
}).start(function () {
    console.log('as_i:    ' + as_i);
    console.log('await_i: ' + await_i);
});
//# sourceMappingURL=opticompare.js.map
