'use strict';

// ensure it works with frozen one

Object.freeze(Object.prototype);

var chai = require('chai');

//
var $as = typeof window !== 'undefined' ? require('futoin-asyncsteps') : module.require('../lib/main-full');

var assert = chai.assert,
    expect = chai.expect;


var $as_test = $as.testcase;

describe('$as_test', function () {
    it('should handle possitive test', $as_test(function (as) {}));

    it('should handle negative test', $as_test(function (as) {
        as.error('MyError');
    }, function (as, err) {
        if (err === 'MyError') {
            as.success();
        }
    }));

    it('should handle failure', function (done) {
        $as_test(function (as) {
            as.error('MyError');
        })(function (err) {
            try {
                expect(err.message).to.equal('MyError');
                done();
            } catch (err) {
                done(err);
            }
        });
    });

    it('should handle failure without exception', function (done) {
        $as_test(function (as) {
            as.error('MyError');
        }, function (as, err) {
            delete as.state.last_exception;
        })(function (err) {
            try {
                expect(err.message).to.equal('Generic Fail');
                done();
            } catch (err) {
                done(err);
            }
        });
    });

    it('should pass Mocha this', $as_test(function (as) {
        this.timeout(1e3); // calls Mocha
    }));

    it('should force failure on negative test', function (done) {
        $as_test(function (as) {}, function (as, err) {})(function (err) {
            try {
                expect(err.message).to.equal('NegativeTestMustThrow');
                done();
            } catch (err) {
                done(err);
            }
        });
    });
});
//# sourceMappingURL=tctest.js.map
